import java.awt.*;
import javax.swing.*;
/**
  An adapter that turns a MoveableShape into a JComponent.
 */
public class ShapeAdapter extends JComponent
{
   /**
       Constructs a JComponent that displays a given moveableshape.
       @param mShape the shape to display
       @param width
       @param height
   */
   public ShapeAdapter(MoveableShape mShape, int width, int height) {
        this.shape = mShape;
        this.width = width;
        this.height = height;
   }
   public void paintComponent(Graphics g)
   {
       Graphics2D g2 = (Graphics2D) g;
       shape.draw(g2);
   }
   public Dimension getPreferredSize()
   {
      return new Dimension(width,
                           height);
   }
    private int width;
    private int height;
    private MoveableShape shape;
}